﻿using UnityEngine;
using System.Collections;
using UnityEngine.Networking;

public partial class CharControl : NetworkBehaviour {
	
	float x;
	float z;
	float moveSpeed = 10.0f;
	bool hasFocus = true;
	
	void OnApplicationFocus(bool focus)
	{
		hasFocus = focus;
	}
	
	void Start()
	{
		if (!isLocalPlayer) {
			GetComponentInChildren<ThirdPersonCamera>().enabled = false;
			GetComponentInChildren<Camera>().enabled = false;
			GetComponentInChildren<AudioListener>().enabled = false;
		}
	}
	
	void Update () 
	{
		if (!isLocalPlayer || !hasFocus) {
			return;
		}
		
		// x is used for the x axis.  set it to zero so it doesn't automatically rotate
		x = 0;
		
		// check to see if the W or S key is being pressed.  
		z = Input.GetAxis("Vertical") * Time.deltaTime * moveSpeed;
		
		// Move the character forwards or backwards
		
		Vector3 force = transform.forward * z * 250; //new Vector3(0, 0.0f, 10 * z * moveForce);
		GetComponent<Rigidbody>().AddForce(force);		
		
		
		// Check to see if the A or D key are being pressed
		if (Input.GetAxis("Horizontal") != 0)
		{
			// Get the A or S key (-1 or 1)
			x = Input.GetAxis("Horizontal") * Time.deltaTime * moveSpeed;
			
			Vector3 hforce = transform.right * x * 150; //new Vector3(0, 0.0f, 10 * z * moveForce);
			GetComponent<Rigidbody>().AddForce(hforce);				
		}
		
	}
}
