﻿using UnityEngine;
using System.Collections;
using UnityEngine.Networking;

public partial class KeyMove : NetworkBehaviour {

	float dx = 0;
	float dy = 0;
	bool grounded = false;
	Transform groundCheck;
	
	float moveForce = 25.0f;
	float topSpeed = 4.0f;
	
	//Plane playerMovementPlane;
	Vector3 cameraOffset;
	bool hasFocus = true;
	
	public Combat combat;
	
	// Use this for initialization
	void Start () 
	{
		//playerMovementPlane = new Plane (transform.up, transform.position + transform.up * 0.15f);
		cameraOffset = Camera.main.transform.position - transform.position;
		groundCheck = transform.Find("shadow");
		
		// listen for die event on server only
		if (NetworkServer.active) {
			//combat.eDie += Die;
		}
	}
	
	void OnApplicationFocus(bool focus)
	{
		hasFocus = focus;
	}

	void FixedUpdate()
	{
		if (NetworkClient.active)
		{
			GetComponent<Rigidbody>().angularVelocity = Vector3.zero;	
			
			if (!isLocalPlayer || !hasFocus) {
				return;
			}
			if (GetComponent<Rigidbody>().velocity.magnitude >= topSpeed) 
			{
				GetComponent<Rigidbody>().velocity = GetComponent<Rigidbody>().velocity.normalized * topSpeed;
			}
			else
			{
				Vector3 force = new Vector3(dx * moveForce, 0.0f, dy * moveForce);
				GetComponent<Rigidbody>().AddForce(force);		
			}
			Camera.main.transform.position = transform.position + cameraOffset;
		}
	}	

	void Update () 
	{
		if (!isLocalPlayer || !hasFocus) {
			return;
		}
		
		grounded = Physics.Linecast(transform.position, groundCheck.position - transform.up * 0.2f);
		
		dx = 0;
		dy = 0;
		
		if (Input.GetKey(KeyCode.A)) {
			dx -= 1;
		}
		if (Input.GetKey(KeyCode.D)) {
			dx += 1;
		}
		if (Input.GetKey(KeyCode.W)) {
			dy += 1;
		}
		if (Input.GetKey(KeyCode.S)) {
			dy -= 1;
		}
		
		if (grounded && Input.GetKeyDown(KeyCode.Space)) {
			GetComponent<Rigidbody>().AddForce(new Vector3(0f, 3000.0f, 0));
		}
		
		/*
		// look at cursor
		playerMovementPlane = new Plane (transform.up, transform.position + transform.up * 0.15f);	
			
		Vector3 cursorScreenPosition = Input.mousePosition;
		Vector3 cursorWorldPosition = ScreenPointToWorldPointOnPlane (cursorScreenPosition, playerMovementPlane, Camera.main);
		cursorWorldPosition.y = transform.position.y;
		transform.LookAt(cursorWorldPosition);
		*/
	}
	
	
	void Die()
	{
		//OverrideClientTransform(Vector3.zero + transform.up * 3, Quaternion.identity, true);
	}

	public static Vector3 PlaneRayIntersection (Plane plane, Ray ray)
	{
		float dist;
		plane.Raycast (ray, out dist);
		return ray.GetPoint (dist);
	}
	
	public static Vector3 ScreenPointToWorldPointOnPlane (Vector3 screenPoint, Plane plane, Camera camera)
	{
		// Set up a ray corresponding to the screen position
		Ray ray = camera.ScreenPointToRay (screenPoint);
		
		// Find out where the ray intersects with the plane
		return PlaneRayIntersection (plane, ray);
	}
	
}
