﻿using UnityEngine;
using System.Collections;
using UnityEngine.Networking;

public partial class PlayerUI : NetworkBehaviour {

	// for drawing UI (ugh)
	Texture box;
	public Texture ui;
	
	float xRatio;
	float yRatio;
	
	// Use this for initialization
	void Start () {
		box = (Texture)Resources.Load("box");	
	}
	
	[Command]
	public void CmdBuyItem()
	{
		Combat combat = GetComponent<Combat>();
		combat.SpendGold(200);
		combat.AddItem (CombatStat.MoveSpeed, 100);
	}
	
	void OnGUI()
	{
		if (!isLocalPlayer) {
			return;
		}
		
		// source art is at 1280x900
		xRatio = Screen.width / 1280.0f;
		yRatio = Screen.height / 900.0f;
		
		float w = Screen.width;
		float h = Screen.height;
		GUI.DrawTexture (new Rect(0,0,w,h), ui);
		
		Combat combat = GetComponent<Combat>();
		if (combat != null) {
		
			//if (combat.target != null)
			//{
			//	combat = combat.target;
			//}
			
			// health bar 414,770 w=500,h=23
			float healthRatio = combat.health / (combat.maxHealth *1.0f);
			GUI.color = Color.green;
			GUI.DrawTexture (ScaleRect (414,770,500 * healthRatio,20), box);
			
			// man bar 414,790 w=500,h=23
			float manaRatio = combat.mana / (combat.maxMana *1.0f);
			GUI.color = Color.blue;
			GUI.DrawTexture (ScaleRect (414,790,500 * manaRatio,18), box);
			
			
			// health 634,770
			GUI.color = Color.black;
			GUI.Label (ScaleRect(634,763,120,30), "" + (int)combat.health + "/" + (int)combat.maxHealth + "  +" + combat.healthRegen.ToString ("F2"));
			GUI.color = Color.white;
			GUI.Label (ScaleRect(635,764,120,30), "" + (int)combat.health + "/" + (int)combat.maxHealth + "  +" + combat.healthRegen.ToString ("F2"));
			
			// mana 634, 790
			GUI.color = Color.white;
			GUI.Label (ScaleRect(634,785,120,30), "" + (int)combat.mana + "/" + (int)combat.maxMana + "  +" + combat.manaRegen.ToString ("F2"));
			
			// str 548, 821
			GUI.Label (ScaleRect(545,812,120,30), "" + (int)combat.strength);
			
			// agil 548, 845
			GUI.Label (ScaleRect(545,837,120,30), "" + (int)combat.agility);
			
			// int 548, 875
			GUI.Label (ScaleRect(545,862,120,30), "" + (int)combat.intelligence);
			
			GUI.Label (ScaleRect(450,812,120,30), "" + (int)combat.attackDamage);
			GUI.Label (ScaleRect(430,862,120,30), "" + (int)combat.armor);
			GUI.Label (ScaleRect(460,862,120,30), "" + (int)combat.moveSpeed);
			
			GUI.Label (ScaleRect(270,873,120,30), "" + (int)combat.currentLevel);
			GUI.Label (ScaleRect(310,873,120,30), "" + (int)combat.experience + "/" + (combat.currentLevel+1) * 100);
			
			GUI.Label (ScaleRect(290,728,120,30), combat.combatName);
			
			GUI.color = Color.yellow;
			GUI.Label (ScaleRect(1176,758,120,30), "" + (int)combat.gold);
			
			if (GUI.Button(ScaleRect (1210, 756, 50, 22), "SHOP")) {
				Debug.Log("Open the shop");
				CmdBuyItem();
			}
			
			GUI.color = Color.white;
			string[] names = {"DM1", "DM2", "REG", "STR"};
			for (int i=0; i < 4; i++) {
				float diff = 0.0f;
				if (combat.abilityTimer[i] >= Time.time) {
					diff = Time.time - combat.abilityTimer[i];
				}
				
				GUI.Label (ScaleRect(624+i*78,830,120,30), diff.ToString("F1"));
				GUI.Label (ScaleRect(614+i*78,850,120,30), names[i]);
			}

			// draw bufs
			int by = 740;
			foreach(var buf in combat.bufs)
			{
				foreach (var mod in buf.mods) {
					string txt = "BUF: " + mod.stat + " amount: " + mod.amount + " expire: " + (buf.expireTimer - Time.time).ToString ("F2") + " seconds";
					
					GUI.color = Color.black;
					GUI.Label(ScaleRect(400-1, by-1, 400, 30), txt);	
										
					GUI.color = Color.white;
					GUI.Label(ScaleRect(400, by, 400, 30), txt);	
					by -= 20;
				}
			}
			
			// draw items
			int ix = 950;
			int iy = 800;
			foreach (var item in combat.items)
			{
				string txt = "" + item.bufs[0].mods[0].stat;
				GUI.color = Color.white;
				GUI.Label(ScaleRect(ix, iy, 200, 30), txt);	
				ix += 55;
			}
		}
		
	}
	
	Rect ScaleRect(float x, float y, float w, float h)
	{
		return new Rect(x*xRatio, y*yRatio, w*xRatio, h*yRatio);
	}
	
}
