﻿using UnityEngine;
using System.Collections;
using UnityEngine.Networking;

public class ThirdPersonCamera : MonoBehaviour {

	public Transform target;
	float distance = 10.0f;
	
	float xSpeed = 350.0f;
	
	//float ySpeed = 120.0f;
	//float yMinLimit = -20f;
	//float yMaxLimit = 80f;
	
	
	float zoomRate = 20f;
	
	float x = 0.0f;
	//float y = 0.0f;
	bool hasFocus = true;
	
	void Start ()
	{
		Vector3 angles = transform.eulerAngles;
		x = angles.y;
		//y = angles.x;
		
		// Make the rigid body not change rotation
		if (GetComponent<Rigidbody>())
			GetComponent<Rigidbody>().freezeRotation = true;
	}
	
	void OnApplicationFocus(bool focus)
	{
		hasFocus = focus;
		if (!focus) {
			x=0;
		}
	}
		
	void LateUpdate () 
	{
		if (!hasFocus || !NetworkClient.active) {
			return;
		}
		
		if (target) {
			//float test = 0f;
			if (Input.GetMouseButton(0))
			{
				x += Input.GetAxis("Mouse X") * xSpeed * 0.02f;
				//y -= Input.GetAxis("Mouse Y") * ySpeed * 0.02f;
				//test = y;
			}
			distance += -(Input.GetAxis("Mouse ScrollWheel") * Time.deltaTime) * zoomRate * Mathf.Abs(distance);
			
			if (distance < 2.5f)
			{
				distance = 2.5f;
			}
			if (distance > 20f)
			{
				distance = 20f;
			}
			
			
			//y = ClampAngle(y, yMinLimit, yMaxLimit);
			//Debug.Log("y: "+y+" test: "+test);
			
			/*
			if( y == yMinLimit && test == yMinLimit)
			{
				// This is to allow the camera to slide across the bottom if the player is too low in the y 
				distance += -(Input.GetAxis("Mouse Y") * Time.deltaTime) * 10 * Mathf.Abs(distance);
			}*/
			
			var rotation = Quaternion.Euler(0, x, 0);
			var position = rotation * new Vector3(0.0f, 4.0f, -distance) + target.position;
			

			target.transform.rotation = rotation;			
			transform.rotation = rotation;
			transform.position = position;

		}
	}
	
	static float ClampAngle (float angle, float min, float max) {
		if (angle < -360)
			angle += 360;
		
		if (angle > 360)
			angle -= 360;
		
		return Mathf.Clamp (angle, min, max);
	}
}
