﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.Networking;

public partial class Barracks : NetworkBehaviour {
	
	public Combat combat;
	
	public Combat spawnCreep;
	public string spawnCreepType;
	public Transform spawnPosition;
	public Transform[] waypoints = new Transform[4];
	
	float spawnInterval = 40.0f;
	float spawnTimer;
	
	public List<Creep> creeps = new List<Creep>();
	
	public override void OnStartServer () {
		combat.EventDie += Die;
	}
	
	void SpawnCreepAtPos(Vector3 position)
	{
		GameObject go = (GameObject)Instantiate(spawnCreep.gameObject, position, transform.localRotation);
		Combat creepCombat = go.GetComponent<Combat>();
		creepCombat.team = combat.team;
		NetworkServer.Spawn (go);
						
		Creep creep = go.GetComponent<Creep>();
		if (waypoints[0] != null) {
			creep.waypoints = waypoints;
			creep.NextWaypoint();
		}
		creeps.Add (creep);
		

	}
		
		// Update is called once per frame
	void Update () {
		if (!NetworkServer.active) {
			return;
		}
		
		if (Time.time > spawnTimer) 
		{
			//SpawnCreepAtPos(spawnPosition.position);
			//SpawnCreepAtPos(spawnPosition.position + transform.forward*4);
			//SpawnCreepAtPos(spawnPosition.position + transform.forward*-4);
			//SpawnCreepAtPos(spawnPosition.position + transform.right*-8); // this would be ranged unit
			
			spawnTimer = Time.time + spawnInterval;
		}
	}
	
	void Die()
	{
		NetworkServer.Destroy(gameObject);
	}
	
}
