﻿using UnityEngine;
using System.Collections;
using UnityEngine.Networking;

public partial class Missile : NetworkBehaviour {

	public Combat target;
	float distance = 0.01f;
	float speed = 0.02f;
	Vector3 startPos;

	public int damage = 10;
	
	[SyncVar]
	public NetworkInstanceId targetId;
	
	// Use this for initialization
	void Start () {
		startPos = transform.position;
		
	}
	
	public override void OnStartClient ()
	{
		if (NetworkClient.active) {
			GameObject obj = ClientScene.FindLocalObject(targetId);
			if (obj != null)
			{
				target = obj.GetComponent<Combat>();
				
				float distance = (target.transform.position - transform.position).magnitude;
				speed = (20.0f/distance) * 0.02f;
			}
		}
	}
	
	
	// Update is called once per frame
	void FixedUpdate () {
	
		if (NetworkServer.active) {		
			if (target == null) {
				NetworkServer.Destroy(gameObject);
				return;
			}
		}
		else
		{
			if (target == null) {
				GameObject.Destroy(gameObject);
				return;
			}
		}
		
		transform.LookAt(target.transform.position);
		transform.position = Vector3.Lerp(startPos, target.transform.position, distance);
		distance += speed;
		
		if (NetworkServer.active) {		
			if ((target.transform.position - transform.position).magnitude < 1.0f)
			{
				// hit target
				//TODO: do damage
				target.TakeDamage(damage, transform.position, DamageType.Physical);
				NetworkServer.Destroy(gameObject);
			}
		}
	}
}
