﻿using UnityEngine;
using System.Collections;
using UnityEngine.Networking;

public class PowerupSpawner : MonoBehaviour {

	public int numPowerups = 5;
	
	public GameObject powerupPrefab;
	public GameObject towerPrefab;
	public GameObject barracksPrefab;
	public GameObject ancientPrefab;
	public GameObject missilePrefab;
	
	static PowerupSpawner singleton;
	
	
	void Awake()
	{
		singleton = this;
	}
	
	public static void SpawnAll()
	{
		//singleton.SpawnTowers();
		//singleton.SpawnBarracks();
		//singleton.SpawnAncients();
	}
	
	void Update () {
		//SpawnPowerups();
		
	}
	
	void SpawnOneTower(float x, float z)
	{
		GameObject a = (GameObject)Instantiate(
			singleton.towerPrefab, 
			new Vector3(x, 3f, z), 
			Quaternion.identity);
		
		//a.GetComponent<Powerup>().mbuf = (Buf.BufType)Random.Range(0,(int)Buf.BufType.Last);
		NetworkServer.Spawn(a);
	}
	
	void SpawnTowers()
	{
		SpawnOneTower (45, 45);
		SpawnOneTower (100, 100);
		SpawnOneTower (200, 200);
		
		SpawnOneTower (0, 45);
		SpawnOneTower (45, 0);
		
		SpawnOneTower (0, 100);
		SpawnOneTower (100, 0);		
		
		SpawnOneTower (0, 200);
		SpawnOneTower (200, 0);		
		
		SpawnOneTower (0, 0);
		SpawnOneTower (-10, 0);		
		SpawnOneTower (0, -10);		
	}
	
	void SpawnOneBarracks(int x, int z)
	{
		GameObject a = (GameObject)Instantiate(
			singleton.barracksPrefab, 
			new Vector3(x, 0.1f, z), 
			Quaternion.identity);
		
		//a.GetComponent<Powerup>().mbuf = (Buf.BufType)Random.Range(0,(int)Buf.BufType.Last);
		NetworkServer.Spawn(a);
	}
	
	void SpawnBarracks()
	{
		SpawnOneBarracks(0,30);
		SpawnOneBarracks(30,30);
		SpawnOneBarracks(30,0);
	}
	
	void SpawnAncients()
	{
		GameObject a = (GameObject)Instantiate(
			singleton.ancientPrefab, 
			new Vector3(-10, 0.1f, -10), 
			Quaternion.identity);
		
		//a.GetComponent<Powerup>().mbuf = (Buf.BufType)Random.Range(0,(int)Buf.BufType.Last);
		NetworkServer.Spawn(a);
	}	
	
	
	void SpawnPowerups()
	{
		if (!NetworkServer.active) {
			return;
		}
		if (Powerup.numPowerups < numPowerups)
		{
			GameObject a = (GameObject)Instantiate(
				singleton.powerupPrefab, 
				new Vector3(Random.Range(-30, 30), 0.7f, Random.Range(-30,30)), 
				Quaternion.identity);
				
			//a.GetComponent<Powerup>().mbuf = (Buf.BufType)Random.Range(0,(int)Buf.BufType.Last);
			NetworkServer.Spawn(a);	
		}
	}
	
	static public GameObject SpawnPowerup(Vector3 pos, string spawnType)
	{
		return (GameObject)Instantiate(singleton.powerupPrefab, pos, Quaternion.identity);
	}
	
	static public GameObject SpawnTower(Vector3 pos, string spawnType)
	{
		return (GameObject)Instantiate(singleton.towerPrefab, pos, Quaternion.identity);
	}	
	
	static public GameObject SpawnBarracks(Vector3 pos, string spawnType)
	{
		return (GameObject)Instantiate(singleton.barracksPrefab, pos, Quaternion.identity);
	}	
	
	static public GameObject SpawnAncient(Vector3 pos, string spawnType)
	{
		return (GameObject)Instantiate(singleton.ancientPrefab, pos, Quaternion.identity);
	}
	
	static public GameObject SpawnMissile(Vector3 pos, string spawnType)
	{
		return (GameObject)Instantiate(singleton.missilePrefab, pos, Quaternion.identity);
	}		
}
