﻿using UnityEngine;
using System.Collections;
using UnityEngine.Networking;

public partial class Respawner : NetworkBehaviour {

	float bufTimer;
	float bufInterval = 2.0f;
	float bufRange = 10.0f;
	
	public Combat combat;
	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {
	
		if (bufTimer > Time.time) 
		{
			// find objects in range
			Collider[] hitColliders = Physics.OverlapSphere(transform.position, bufRange);
			foreach (Collider coll in hitColliders)
			{
				Combat newTarget = coll.gameObject.GetComponent<Combat>();
				if (newTarget == null) {
					continue;
				}
				if (newTarget.team != combat.team) {
					continue;
				}
				
				if (newTarget.health < newTarget.maxHealth)
				{
					newTarget.AddBuf(CombatStat.Health, 400, bufTimer);
				}
				if (newTarget.mana < newTarget.maxMana)
				{
					newTarget.AddBuf(CombatStat.Mana, 400, bufTimer);
				}
			}
			
			bufTimer = Time.time + bufInterval;
		}
	}
}
