﻿using UnityEngine;
using System.Collections;
using UnityEngine.Networking;


public partial class Tower : NetworkBehaviour {

	public GameObject missilePrefab;
	public Combat combat;
	public Transform muzzle;
	
	public Vector3 targetDir;
	
	Missile activeMissile;
	
	public override void OnStartServer()
	{
		name = "Tower[ " + GetComponent<NetworkIdentity>().netId + " ] " + combat.team;
		combat.EventDie += Die;
	}
	
	void FixedUpdate()
	{
		if (combat.target == null) {
			// no target.. spin
			transform.Rotate(0,1,0);
		}	
	}
	
	void Update () 
	{
		if (combat.target != null)
		{
			// rotate to face target
			targetDir = combat.target.transform.position - transform.position;
			float step = 10 * Time.deltaTime;
			Vector3 newDir = Vector3.RotateTowards(transform.forward, targetDir, step, 0.0F);
			newDir.y = 0;
			transform.rotation = Quaternion.LookRotation(newDir);
		}
			
		if (!NetworkServer.active) {
			return;
		}
		
		if (combat.CanAttack() && combat.target != null)
		{
			if (activeMissile == null) 
			{
				if (combat.CanAttack() )
				{
					GameObject obj = (GameObject)Instantiate(missilePrefab, muzzle.transform.position, transform.rotation); //Quaternion.identity); //LookRotation(targetDir));
					activeMissile = obj.GetComponent<Missile>();
					activeMissile.target = combat.target;
					activeMissile.damage = (int)combat.attackDamage;
					activeMissile.targetId = combat.target.GetComponent<NetworkIdentity>().netId;
				
					NetworkServer.Spawn(obj);
					combat.HasAttacked();
				}
			}
		}
	}
		
	void Die()
	{
		NetworkServer.Destroy(gameObject);
	}
	
}
